%global pkg_name gtk2hs

%bcond_without docs
%bcond_without prof
%bcond_with shared

%bcond_without cairo
%bcond_without svgcairo
%bcond_without gio
%bcond_without opengl
%bcond_without gstreamer
%bcond_without vte

# currently segfaulting
%bcond_with mozembed

# external haddock
%bcond_with haddock

%global ghcpkgdir %{_libdir}/ghc-%{ghc_version}/%{pkg_name}-%{version}

# ghc does not emit debug information
%global debug_package %{nil}

%global common_descr \
A Gtk+ binding for the functional language Haskell featuring automatic memory\
management, unicode support, and wide coverage of Gtk+ 2 widgets.

Summary:        Haskell binding for gtk2 and related libraries
Name:           ghc-%{pkg_name}
Version:        0.10.1.20100110
Release:        4%{?dist}
# cairo/ and svgcairo/ are FreeBSD
# compat/ is BSD
# tools/c2hs (used to build) is GPLv2+, LGPLv2+
# except tools/c2hs/base/general/{Binary.hs,FastMutInt.hs} from ghc (BSD)
# gstreamer, gio, gnomevfs are LGPLv3
# rest is all LGPLv2+
License:        LGPLv2+ and LGPLv3
Group:          Development/Libraries
# snapshot tarball obtained by
#  darcs get --partial http://code.haskell.org/gtk2hs/
#  cd gtk2hs ; darcs dist darcs dist --d gtk2hs-%{version}.%{snapdate}
Source:         http://prdownloads.sourceforge.net/%{pkg_name}/%{pkg_name}-%{version}.tar.gz
URL:            http://gtk2hs.sourceforge.net/
Patch1:         gtk2hs-0.10.1.20100110-Graphics.UI.Gtk.Display.StatusIcon-haddock-rec.patch
# fedora ghc archs:
ExclusiveArch:  %{ix86} x86_64 ppc alpha
BuildRequires:  ghc, ghc-rpm-macros >= 0.5.5
BuildRequires:  happy, alex
BuildRequires:  ghc-mtl-devel, ghc-mtl-doc, ghc-mtl-prof
%if %{with docs}
%if %{with haddock}
BuildRequires:  haddock >= 2.4.1
%endif
BuildRequires:  ghc-doc
%endif
%if %{with prof}
BuildRequires:  ghc-prof
%endif
BuildRequires:  gtk2-devel
BuildRequires:  gtksourceview2-devel
BuildRequires:  libglade2-devel
BuildRequires:  GConf2-devel, dbus-devel
%if %{with gstreamer}
BuildRequires:  gstreamer-devel, gstreamer-plugins-base-devel
%endif
%if %{with mozembed}
BuildRequires:  xulrunner-devel-unstable
%endif
%if %{with cairo}
BuildRequires:  cairo-devel
%if %{with svgcairo}
BuildRequires:  librsvg2-devel
%endif
%endif
%if %{with opengl}
BuildRequires:  gtkglext-devel
%endif
%if %{with vte}
BuildRequires:  vte-devel
%endif

%description
%commom_descr

This package also includes the bindings for cairo, gconf, glade, glib, and
sourceview.  The libraries are compiled for ghc-%{ghc_version}.


%package common
Summary:        Haskell Gtk+ GUI library common files
Group:          Development/Libraries

%description common
%common_descr

This package contains some common files shared by the subpackages.


%if %{with docs}
%package doc
Summary:        Haskell Gtk+ GUI library documentation
Group:          Development/Libraries
Obsoletes:      gtk2hs-doc < 0.9.13-3

%description doc
%common_descr

This package contains the gtk2hs documentation.
%endif


# subpackage name lib [dep] [obsoletes]
%define pkg_filelists()\
cat > ../ghc-%1-devel.files << EOF\
%defattr(-,root,root,-)\
%{ghcpkgdir}/%1.cabal\
%{ghcpkgbasedir}/package.conf.d/%1-%{version}.conf\
%{ghcpkgdir}/libHS%1.a\
%{ghcpkgdir}/HS%1.o\
EOF\
find $RPM_BUILD_ROOT%{ghcpkgdir}/imports/%1 -type d -printf "%%%%dir %%p\\n" >> ../ghc-%1-devel.files\
find $RPM_BUILD_ROOT%{ghcpkgdir}/imports/%1 -type f -name "*.hi" >> ../ghc-%1-devel.files\
%if %{with prof}\
cat > ../ghc-%1-prof.files << EOF\
%defattr(-,root,root,-)\
%{ghcpkgdir}/libHS%{1}_p.a\
EOF\
find $RPM_BUILD_ROOT%{ghcpkgdir}/imports/%1 -type f -name "*.p_hi" >> ../ghc-%1-prof.files\
%endif\
echo -n > ../ghc-%1-doc.files\
sed -i -e "s!${RPM_BUILD_ROOT}!!g" ../ghc-%{1}*.files\
%{nil}

%ghc_binlib_package -n cairo -c cairo-devel -h ghc-glib-devel,ghc-mtl-devel
%ghc_binlib_package -n gconf -d GConf2-devel -h ghc-glib-devel
%if %{with gio}
%ghc_binlib_package -n gio -c glib2-devel -h ghc-glib-devel
%endif
%ghc_binlib_package -n glade -c libglade2-devel -h ghc-gtk-devel
%ghc_binlib_package -n glib -c glib2-devel
%if %{with gstreamer}
%ghc_binlib_package -n gstreamer -c gstreamer-devel -h ghc-glib-devel,ghc-mtl-devel
%endif
%ghc_binlib_package -n gtk -c gtk2-devel -h ghc-cairo-devel,ghc-glib-devel
%if %{with opengl}
%ghc_binlib_package  -n gtkglext -c gtkglext-devel -h ghc-gtk-devel
%endif
%ghc_binlib_package -n gtksourceview2 -c gtksourceview2-devel -h ghc-gtk-devel
%if %{with mozembed}
%ghc_binlib_package -n mozembed -c xulrunner-devel -h ghc-gtk-devel
%endif
%ghc_binlib_package -n soegtk -c gtk2-devel -h ghc-gtk-devel,ghc-cairo-devel
%ghc_binlib_package -n svgcairo -c librsvg2-devel -h ghc-cairo-devel,ghc-glib-devel,ghc-mtl-devel
%if %{with vte}
%ghc_binlib_package -n vte -c vte-devel -h ghc-gtk-devel
%endif


%prep
%setup -q -n %{pkg_name}-%{version}
%patch1 -p1 -b .orig
[ -x configure ] || autoreconf


%build
%if %{with docs}
%if %{with haddock}
export HADDOCK=%{_bindir}/haddock-2.4.2
%endif
%endif
%configure \
        --with-hc=ghc-%{ghc_version} \
        --enable-packager-mode \
%if %{with docs}
        --enable-docs \
%endif
%if %{with prof}
        --enable-profiling \
%endif
        --disable-split-objs \
        --enable-gio \
        --enable-gtk \
        --enable-libglade \
        --enable-gconf \
        --enable-gstreamer \
        --enable-gtksourceview2 \
%if %{with mozembed}
        --enable-mozilla \
%endif
%if %{with opengl}
        --enable-opengl \
%endif
%if %{with cairo}
        --enable-cairo \
%if %{with svgcairo}
        --enable-svg \
%endif
%endif
%if %{with vte}
        --enable-vte \
%endif
%{nil}

# C locale to workaround c2hs failing in CJK locale
LANG=C make all pkglibdir=%{ghcpkgdir} htmldocdir=%{ghcdocdir}


%install
make install DESTDIR=%{buildroot} pkglibdir=%{ghcpkgdir} htmldocdir=%{ghcdocdir}

mkdir %{buildroot}%{ghcpkgbasedir}/package.conf.d
for i in %{buildroot}%{ghcpkgdir}/*.package.conf; do
  new=$(basename $i | sed -e "s/.package.conf$/-%{version}.conf/")
  mv $i %{buildroot}%{ghcpkgbasedir}/package.conf.d/$new
done

for pkg in cairo gconf %{?with_gio:gio} glade glib gstreamer gtk gtkglext gtksourceview2 %{?with_mozembed:mozembed} soegtk svgcairo %{?with_vte:vte}; do
cd $pkg
%pkg_filelists ${pkg} 
cd ..
done 


%clean
rm -rf %{buildroot}


%if %{with docs}
%post doc
%ghc_reindex_haddock

%postun doc
%ghc_reindex_haddock
%endif


%files common
%defattr(-,root,root,-)
%doc AUTHORS COPYING*
%dir %{ghcpkgdir}
%dir %{ghcpkgdir}/imports
%dir %{ghcpkgdir}/include
%{ghcpkgdir}/include/gtk2hs-config.h


%if %{with docs}
%files doc
%defattr(-,root,root,-)
%doc ChangeLog TODO demo
%{ghcdocdir}
%endif


%changelog
* Sat May 22 2010 Jens Petersen <petersen@redhat.com> - 0.10.1.20100110-4
- fix erroneous ghc-gtk-devel dependency on glib-devel

* Mon Jan 18 2010 Jens Petersen <petersen@redhat.com> - 0.10.1.20100110-3
- build with --disable-split-objs for ghc-6.12.1 for now (Bertram Felgenhauer)
  to fix linking errors with programs

* Fri Jan 15 2010 Jens Petersen <petersen@redhat.com> - 0.10.1.20100110-2
- fix prof filelists using find in pkg_filelists

* Fri Jan 15 2010 Jens Petersen <petersen@redhat.com> - 0.10.1.20100110-1
- update to darcs snapshot for ghc-6.12.1 build
- add shared bcond (disabled until work out how to build shared)
- build vte 
- override ghcpkgdir to hardcode pkg path
- drop buildroot
- BR mtl
- drop old compat package
- use ghc_binlib_package from ghc-rpm-macros-0.5.5
- replace subpackage macro with custom pkg_filelists macro
- force package.conf files into package.conf.d

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat May 30 2009 Jens Petersen <petersen@redhat.com> - 0.10.1-4
- disable mozembed again since it is segfaulting
  http://hackage.haskell.org/trac/gtk2hs/ticket/1168
- let subpackages provide ghc-pkg_name

* Sun May 24 2009 Jens Petersen <petersen@redhat.com> - 0.10.1-3
- enable mozembed and drop gnomevfs bcond
- remove some redundant snapdate usage

* Sat May 16 2009 Jens Petersen <petersen@redhat.com> - 0.10.1-2
- add bcond haddock
- buildrequire ghc-rpm-macros

* Mon May 11 2009 Jens Petersen <petersen@redhat.com> - 0.10.1-1
- update to 0.10.1

* Sat Apr 25 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-5
- rebuild against ghc-6.10.2
- use haddock-2.4.2
- update to new ghcpkgdir and ghcdocdir macros

* Tue Apr 14 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-4
- use define not global to define subpackage since it broke ?3: expansion
- require the subpackage dependency with -devel suffix

* Mon Mar  9 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-3
- use global
- update arch list
- rename library subpackages to devel and obsolete old packages
- add prof subpackages

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 12 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-1
- rebuild for official 0.10.0 release

* Sat Feb  7 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-0.1
- update to 0.10.0 prerelease
- adds .cabal files
- gstreamer, gio, gnomevfs  are LGPLv3
- subpackage all the ghc packages
- add compat and common packages for upgrades
- gtksourceview2 replaces sourceview
- fix docs bcond, and add bcond for svgcairo, gio, gstreamer, prof, and gnomevfs
- build svgcairo and gstreamer
- use common_descr for descriptions

* Fri Feb  6 2009 Jens Petersen <petersen@redhat.com> - 0.9.13-8.20081108
- use bcond

* Wed Dec 17 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-7.20081108
- turn on docs and buildrequire ghc-doc
- buildrequire dbus-devel for gconf private

* Fri Dec  5 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-6.20081108
- install the .o files at build time rather than generating them at install
  (reported by Gregory Weber, #250767)
- update docs building to haddock 2.4.1

* Sun Nov  9 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-5.20081108
- gtk2hs was renamed to ghc-gtk2hs (#468314)
- update to snapshot of darcs tip which builds with ghc-6.10.1
- disable docs for now since haddock-2.2 cannot handle them
- add some snapshot logic
- buildrequires happy and alex
- gtk2hs-fasm-0.9.13.patch is no longer needed

* Fri Nov 07 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-4
- Rebuild for GHC 6.10.1

* Fri Oct 24 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-3
- install docs in ghc haddock dir with htmldocdir and use ghc_reindex_haddock
- rename gtk2hs-doc to ghc-gtk2hs-doc
- use pkg_name, pkg_libdir, and pkg_docdir for Haskell packaging guidelines
- don't override __spec_install_post

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-2
- Try to fix ppc build due to ghc 6.8.3 -fvia-C bug

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-1
- Update to 0.9.13

* Mon Jun 23 2008 Jens Petersen <petersen@redhat.com> - 0.9.12.1-10.fc10
- build with ghc-6.8.3
- add build_docs switch
- use haddock09 to fix build failure (#440493)
- merge ghcver subpackage into ghc subpackage in line with ghc
- obsolete old ghcver packages
- add opengl gtkglext subpackage (Ian Collier, #327541)
- require xulrunner-devel instead of firefox-devel
- update prereq's to script requires

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.12.1-9
- Autorebuild for GCC 4.3

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Fix typo

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Build with ghc 6.8.2

* Fri Nov 23 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-6
* Exclude alpha

* Fri Nov 09 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-5
* Bump revision number

* Wed Nov 07 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-4
* Revert to 0.9.12 spec file

* Thu Aug 16 2007 Jens Petersen <petersen@redhat.com>
- update License field

* Fri Jul 27 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12-1
- update to 0.9.12 release

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-4
- disable ppc64 build (#239752)

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-3
- rebuild against ghc 6.6.1

* Tue Apr 10 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-2
- obsolete mozembed when it is not built

* Thu Mar 22 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-1
- update to 0.9.11 release
- disable mozembed for now since the firefox minor version keeps changing
  (#223880)

* Thu Nov 16 2006 Jens Petersen <petersen@redhat.com> - 0.9.10.2-0.1
- update to latest darcs snapshot for ghc66
- add soegtk and remove mogul ghc packages

* Thu Sep 28 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-4
- rebuild for FC6

* Sun Aug 20 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-3
- drop explicit firefox-devel version to avoid rebuild every time it changes
  (cf #202395)

* Wed Aug  2 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-2
- mozilla-devel is now firefox-devel

* Mon May 15 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-1
- rework packaging to keep all the ghc packages together except mozembed
- update mozilla version to 1.7.13

* Mon May  1 2006 Gérard Milmeister <gemi@bluewin.ch>
- spec file cleanup
- ghost the .o files generated at install time
- move the docs to a versioned dir and include the demos
- make all subpackages own %%{_libdir}/ghc

* Tue Apr 25 2006 Jens Petersen <petersen@redhat.com>
- use module names for the subpackages
- subpackage mogul
- own the include dir

* Sat Apr 22 2006 Jens Petersen <petersen@redhat.com>
- initial packaging for Fedora Extras
- define ghcpkg_inst and ghcpkg_uninst for post and preun scripts and
  silence ghc-pkg
- own include/

* Wed Oct 26 2005 Jens Petersen <petersen@redhat.com> - 0.9.9.7-0
- rc

* Wed Sep 21 2005 Jens Petersen <petersen@redhat.com> - 0.9.9-2
- build with ghc-6.4.1

* Sat Jul 30 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-3
- drop old conflicts

* Tue Jul  5 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-2
- use %%configure to configure for arch to avoid gclosure ghci-6.4 linking
  problems on i386

* Wed Jun 22 2005 Jens Petersen <petersen@haskell.org> - 0.9.8-1
- update to 0.9.8
- use new --enable-packager-mode and --enable-* configure options

* Thu Jun  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7.91
- update to rc1
- add build_mozembed macro and use it

* Mon May  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7-2
- add gtk2hs-0.9.7-ghc64.patch and build with ghc-6.4 (Duncan Coutts)
  - .pkg files are now .cabal files

* Tue Jan 18 2005 Duncan Coutts <duncan@coutts.uklinux.net>
- cleanup requirements, summaries, descriptions, and configure invocation
- update preun scripts

* Thu Aug 19 2004 Jens Petersen <petersen@haskell.org>
- use suffix -ghc621 instead of -ghc6.2.1 and conflict with old packages
- buildrequire ghc-doc and gtk2hs-doc-ghc621 requires ghc-doc
- move docs and demo files to %{_defaultdocdir}/gtk2hs

* Mon Aug 16 2004 Jens Petersen <petersen@haskell.org>
- update to 0.9.6

* Thu Jul 22 2004 Jens Petersen <petersen@haskell.org>
- split sourceview and glade into separate subpackages
- require -devel packages rather than lib pkg for gtk2, gtksourceview,
  and libglade2

* Wed Mar 24 2004 Jens Petersen <petersen@haskell.org>
- enable gtksourceview and glade configure options
- use mkdir -p instead of mkdirhier
- update file locations in %%post and %%preun scripts
- buildrequire libglade2-devel

* Tue Nov 11 2003 Jens Petersen <petersen@haskell.org>
- use %%c2hs instead of "--with c2hs" to configure c2hs program
- clean demo to avoid binary files in docs dir

* Mon Nov  3 2003 Jens Petersen <petersen@haskell.org>
- add sourceview package to %%post and %%preun
- install gtksourceview haskell.lang language-spec

* Thu Jul 31 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0.1
- put demo dir in docs dir rather than individual source files

* Thu Jul 10 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0
- name ghc subpackage "ghc%%{ghc_version}"

* Wed Jun 18 2003 Jens Petersen <petersen@haskell.org>
- require and buildrequire %{_bindir}/ghc-%%{ghc_version}

* Wed May 21 2003 Jens Petersen <petersen@haskell.org>
- add -g option to ghc-pkg -u so that ghci object gets generated
- delete them when uninstalling
- build and include mogul documentation

* Thu May 15 2003 Jens Petersen <petersen@haskell.org>
- use new DESTDIR make variable, so no longer need to fix config files in post
- remove buildroot before install
- build and include gtk docs

* Fri Jan 10 2003 Jens Petersen <petersen@haskell.org>
- made into .spec.in file
- let configure set the version
- update description
- introduce --with-c2hs rpmbuild option
- use perl to remove buildroot traces from package conf files
- simplify ghc-pkg update commands

* Tue Dec 17 2002 Jens Petersen <petersen@haskell.org>
- latest cvs with ghc 5.04.2

* Thu Sep 26 2002 Jens Petersen
- build with ghc-5.04.1

* Fri Aug  2 2002 Jens Petersen
- only include demo source in doc dir

* Fri Jul 26 2002 Jens Petersen
- build with ghc-5.04
- cvs update

* Wed Jul 10 2002 Jens Petersen
- my current branch

* Wed May  1 2002 Jens Petersen
- patch TreeViewColumn.chs to make it usable

* Tue Apr 23 2002 Jens Petersen
- 0.9.0
- update gtk2 and mogul ghc-pkg entries on upgrade

* Fri Apr 12 2002 Jens Petersen
- adapt for gtk2hs
- fix mk files for buildroot install
- post and postun scriptlets for pkg config

* Tue Mar 12 2002 Manuel Chakravarty
- require a specific Haskell compiler (namely, the one for which the packages 
  was compiled)

* Sat Feb 17 2001 Manuel Chakravarty
- derived from C->Haskell's .spec file
